// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	"github.com/pkg/errors"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Package list including NEVRA
	Packages []PackageMetadata `json:"packages"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// DistributionList defines model for DistributionList.
type DistributionList struct {
	// Distribution name
	Map *DistributionList_Map `json:"map,omitempty"`
}

// Distribution name
type DistributionList_Map struct {
	AdditionalProperties map[string]interface{} `json:"-"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    *string `json:"sigmd5,omitempty"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// PostDepsolveBlueprintJSONBody defines parameters for PostDepsolveBlueprint.
type PostDepsolveBlueprintJSONBody DepsolveRequest

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody PostDepsolveBlueprintJSONBody

// Getter for additional properties for DistributionList_Map. Returns the specified
// element and whether it was found
func (a DistributionList_Map) Get(fieldName string) (value interface{}, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for DistributionList_Map
func (a *DistributionList_Map) Set(fieldName string, value interface{}) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]interface{})
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for DistributionList_Map to handle AdditionalProperties
func (a *DistributionList_Map) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]interface{})
		for fieldName, fieldBuf := range object {
			var fieldVal interface{}
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return errors.Wrap(err, fmt.Sprintf("error unmarshaling field %s", fieldName))
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for DistributionList_Map to handle AdditionalProperties
func (a DistributionList_Map) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, errors.Wrap(err, fmt.Sprintf("error marshaling '%s'", fieldName))
		}
	}
	return json.Marshal(object)
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get all of the supported distribution repository details
	// (GET /distributions)
	GetDistributionList(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetDistributionList converts echo context to params.
func (w *ServerInterfaceWrapper) GetDistributionList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetDistributionList(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/distributions", wrapper.GetDistributionList)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXPbOLL4V0HpTVVmftF9WLKrpvbJ8iXftmQ79irlhUhIgkUCDABKluflu/8KBylS",
	"pK44mdnZzR+7E4s4Gg10o2/8kbGo61GCiOCZvT8yHmTQRQIx89cQyf/aiFsMewJTktnLXMMhApjY6DWT",
	"zaBX6HoOijWfQMdHmb1MKfP1azaDZZ8vPmKzTDZDoCu/qJbZDLdGyIWyi5h58ncuGCZD1Y3jt5S5L323",
	"jxigA4AFcjnABCBojYAZMApNMEAITbG4FB7VdhU8X4OPaujmQ+ewVW45lKCWRB9XE0HbxhJM6Fwz6iEm",
	"sARkAB2Oshkv8tMfGYaGaj2JibIZPoIMPU+xGD1Dy6K+2RizsszePzOlcqVa26k3doulcuZzNqMwkTqW",
	"+QEyBmdq7Qx98TFDthzGwPA5bEb7L8gSsp9e353nUGhfKdTzb15gCHgG+bkp4iJXymT/zGVnM5xAj4+o",
	"eNa7HYXJneWCr0mo0hGWDus6NHYEFL6mkhiioIvjEEEX54pWo1Ks71bq9Vptt2ZX+2kY2xLFC4uR82bX",
	"nIFO5T1HwPP7DrY0CQ+g74iwXZyk2wPAkQCCAvUZ/CpGCJguQBHvb1kAgUPJMAtof+BzCwpkg7vb8x7B",
	"HDAkfEaQnQdtwQF69TCDcmjg4uFIgD4CnFKCGBAjSMCAMkDFCDHgq7X1iIBsiATP90iPzGERzEdyWj6i",
	"TCAmZwORyQAkdo/g+ISYAwk7hy4CkKup5N/R6cB8tvkW9Sl1ECTv39TNtnPZUfSZk86Ko1PIRqnjv/kM",
	"vee4jGYeYs+T5yEiSOMzdnQy93L58ZPTGlHKkcLx/QVou/JeOpHD3IP5KFlg48EAMUQEGCAofIY4oAQo",
	"gAGU/5tA7MC+g3rERh4iNiZD2UKOmxhObxwiviuxoYC6L0cwMqdPLOEJWc7CNSaPCB2oKfTBQDZQHeQp",
	"Bq7P1cH1Cf7iy7tWNRziCSKAIU59ZiEwZNT38urMyknk6aMuFpI0Boy6qovcOcSFPMgMEpu6gBIE+pAj",
	"W64Qgru79gHAvEfMCpFtFhjlkAqwNBbkUCuyU9EFnpsvwSI9RidYLjIA/1mBnwXTEWJ6C9Uskt58x1aL",
	"D/ACiew2xFwgpuA7oVNJog7mAkDHAQEYfK9HRkJ4fK9QsKnF8y62GOV0IPIWdQuI5HxesBxcgHLvC4Z3",
	"/2OC0fR39VPOcnDOgQJx8T/wLWDuz3Ki53CSDwrlEuLgJ4l6QgXgHrLwACM7C7CQP9rI9q3YhizBwyLS",
	"Jb0jX9JHOueP9l19uuLHZQN0L4LSpb4Fya0Z5ljNmHZ/+/0QhGdsJ4FqH0iQos2+AZgqqtmNftnKwX65",
	"mqtWS5XcbtGq5XZK5UpxBzWKu6icBp1ABBKxAi4JhG60GVTmCA4wsdVeawrVPOWaMgGdTc5icA4FnqCc",
	"jRmyBGWzwsAnNnQREdDhia+5EZ3mBM3JqXMa5AUk1aw6GtT6O7mSVRnkqjYs5uBOuZwr9os7xXJl167b",
	"9bVXyRxjyb1NnMA1F8KyCyfOITdhOQtARgZIA2Hf8ZHHMBFbXkUWJQJiYpSghTsn+KZPB5enALl9yb6J",
	"FBtGSB4K6ADIxABaUqoMBdVfGBpk9jL/U5jrXAWjVRTCcdMEWMvngrr4DYYX66qhwmW34t2+LtyfKZKz",
	"jblgNLnqrhTJ5Dfc9xXpCgp8jkIRx9JaUB60B8BBAwGQ64mZ+jSiXPSIHhhMseMoSuJJ2h4gmzKYq+ym",
	"EbA6ZzxNF7XGkkj1dwlWX96XXEDHQfamyDejaOaWgn+X2r7RKuPTNwmADjaynqdH4VkpJcq9tNXPfWiN",
	"p5DZXGEJCtjHDhYztfptoEsDLKCdBL4CWJZi7L24SoNmghhPlQaagCN3ghgwLQBRanxs++v5er5eXEvy",
	"64m9lSCWbUgfWoiJ9dTabMlmsak0/WgujdMwfzD/KJFvMQRFKNyFTANvwzWCIWdp2zGw6br+RwdXqiVO",
	"Pd1H8ufvBWq4P3LUVHDlbDMukJsiTkpRjw7AvA1wpWjmUUxEBMRvAsZMmgpSGs85JFJZAEft6w5wqY1S",
	"FbkBZmgKHWcLSEyHgNstx8Kc2W236qX8TfLodEWlRckAD5XOFDBz1TBN3xkSHFwsq6BoB+2ULU5xH0U/",
	"zzaaYGuNshTtAHSHLLB8JtU7ZwYocWbychn4Tng3IXuIchy7nqNk81zA8RiQS1i4hAo2mhS4DVMXGHRc",
	"u8Kw4ddsZowYQWuPwZluZXQqB61rf65bfc1mqIcIt6C38UG78hDptJrX+ppgQm0GJsNndZZjOjf0Bc05",
	"EzeheXeQgywBRlIK1qLB2EjLwQ0fjozsPPgQDPRBf5eiA4NT4BMHcd4jQoncUheX6illwKUMxSgcS20B",
	"WyNgQY6kxB2Oc35/kQcf1NjQmcIZ7xGfIy5/zwIkNebpCCnGZaYgFKBXwWB0/Dz4wOD0A1A9JWQh+LxH",
	"0gZZAmfcOsDgNJPNaPyFqPycqtB5lONl98Zt5Ksk+inDAsl/FJCwCjPfzav+ebsQ59DGnnBJBZIohkJ+",
	"4wEShBLCABSg72PHBgK7KL+5UBIepxC61DuIjbi7bqjbk85F4iZl3vp+18luHDHJE9aC3wnayT58NEaz",
	"5eyW8xEYoxnfFDWdzskZSsWGxPEbJWupuxu0+5rN+FwznHTY5Nf33H93PE3j+LpKvlL3d4qIp5UUdUWv",
	"kxn0OYtLXjYUMF3dkpAH/F+NDjnwHChHRq9iqbaQHEzdf4sjQTDEtqRlaEwk5n6b3wmMKucAJehqkNn7",
	"Z1LaDn/BRKChROhnrTSkOc8QczGXQjAHeoDwolIQYQKoJaC6vlwoYoAUd6rVtOV6UIzSBH0xAqFK6sTX",
	"pFiHOzO/J0ZMP3RXU6J9b3H8+QH+ZK/vhL4FqV+t8PO6UzmXHuNHy8Uk3Zsof42ux4iWmID+TCAeXUa5",
	"VK1XG5WdaiObec0Nac6A4mMidqpaSQyugbg1ozCBbK1aE+mcDeFds+C5gLlSwVmU6XU3G1hGtNO8M+G9",
	"oUYNSuc76jP4VWq9lAnAIBki/psy1XqMCmpRR7ElKZ1E0fjPTLm8Jywvk800iuYf2IWe+ud2Tr0NOX2w",
	"4CjHl7xVW6A2YZbBCE+q13bMMhS2EodS8jsuGIJu6nJfOCXPAmKHql/WgBhMc9q5uuyGnSRroA62ZqmG",
	"z2tfSOoNjdZAtwXtg4Bpy4sZSH7Ns4BLRgIFgGSmhXBiSVEpNMsDQXtEntvhSPBQCpRSjwsFtqDjzOSJ",
	"I0jZww1bkitxsBwqmNzMbFHCqWPkEcMJ9zK+r4yPSf7HqKRes8rkydkWixEMLvKh+UwriTMiFCU2vg85",
	"8pkTP39zdhEYjS2b5BmyR1AbjC19ERZszEWBjZDTKDQKr42d551qQY5IeYHyQgxbDKeawhfoCCltNoq5",
	"mBbroKU2pqE3tEbIGqd3HXpDJTRFV7kWmCU76CIBHUzG6ZhyMWOU8bw2IHqMyu3IUzYsBP3+IQXk3wMD",
	"Y7nnF4vlHcis0e8agxugTU/iYC6SQIQwyM95CxFBuZr/Hww5CHL0eyOnST0yM5T/v1PVvyj49iFHV51N",
	"YFHmyOcRFQP8mm5p4nJTOVAtIcNiJu83gSLyhnJmB6d0mTt6uX2RYSqHjXwMb2+tzzyvPh6cOxPE8GCW",
	"9nnRzL+G2u6MtLKFnW+dIXyYxjG1/IjtwPot+SCCdiBBBHpzNgUjy+zXTe3FpAMwBz5i34G2rX3EUrIS",
	"NCrez4+gal7ahNZHNM3G0zUTfOBANgChqyltyFRNSWpIOtxDKkox6Y/zUQ7Z5VqttAuazWazVbl8g62S",
	"83TQLl12D2vyt/YlOz47ZBeP+OPFxd3UP4G3zVP39py2324H5S8HZfug9lbc774Wdl7TYEp6kORySumi",
	"MudTytL8gMZRbRoALiBTN5kYgV92fsmCX2q/ZKWc+0u5/0togegjwAWV9x/kPQIJQMRiM0/eccFIeXAl",
	"RohNccRw0UdAKP3I1iL0XJ3pkbBflCajgVJIC32LDvchJkB9NMczVa5PO9aSfL7lVG9qmU81lm8ZS4Tc",
	"59AwHxEmc7nc/uFx+xK0Dm+77aN2q9k9zOVyvR65aLdbxYNWq9nHw+a0vd8ctu/a+Xy+1yO5XO7w8mCh",
	"yzsC6ebApa4+EiW4T21FPXNdaJU4khJlqBTL6C+3iHuUmPhDx9lg1CsF2S1SITEWUvrXglvWjhNTqVxB",
	"1dpOPYcau/1cqWxXcrBa28lVyzs7tVq1WiwWi+vFtE14eri6ucf42xe1qn3ML62n1fhs2/9BmNRLOqdD",
	"/l0XpZzuymiYKt0ZEOJqsmQabAAt9MfXtItpTF/wWhM5fcFqLelRAAaglai4gAQPEBffFR9udND3I2PR",
	"MBCOvnplSMDAgva9FkalzIqeLeq6WKQGzvw6gnz0W3BTyB0QwDTPfoNPWstCmFiOr2LwLg/vb5tb+qVD",
	"RGygp0fwd6sD5dZeS4QKHd4836GF4Ixsph+GnXz+uniR9aMhKRtZaLeP/0gJ+4iEbsQ5ktQkc43M0vBF",
	"NsfLSo+XbBzgcLHz5paWxWG+lU0kqCiGgMi2d/avLr4vcwyWmRSx5VzAppbvKoO21MJU6oL2m2niCc0f",
	"OpwmevY3GnAeJmqcP4fzGXzuKyvMSEmqAkjNVAAxpWognlU+rWAQ7RNCZIIZJXJ8ZdqLtOgRaAkfOsAY",
	"JkIHrZp3U6JVGy6nT/WWrOKLeviVPPF7CBFpVx8Px12/NCNhZGNd0ZYUMR8ljSA2hEfSxXygzfrEEHmv",
	"8mgW98EMFF/gJvtyyBhlKWZRJCBWxrFFc1DMvgB5quKeFI3CxgkA9HokNzTuWu5bFuJyLQOIHZ9JDcqE",
	"g8sFRXTasGGCa87D+BIrWxEJnoimC2IMw7jhpSHYOg4zzWlsjvHc1hoMGkQsxr00ypLLZnnzkzI6qln3",
	"BBymGhcc/jw34STddow6oHveAaoNHmArcDSEk6oci3XGH7PAVNUqWNJ78g5WbEu4H0ZVt+KxnwuhI5Qr",
	"ppmKKjhMYeFwuOUMOjI9VSFYh5sIL9zCSIaH5u5fNC/K3wOOH0ioiXyG+WJMMkVwxtINGyb9ZMFddXNw",
	"mZ4osYCbLz6c5TEtuDMTtV8w+7G3AmuLiS3ZYMmpp02JVRtY9v9NDPvK+Po89IbpBlj9ObDUprd5l2/A",
	"WAp/Gv9/uPH/u9ntOXee32uV/yvDb+OB+98r7v55dXjWoQomi7aJRYNHHKyYgLgmlwfdEeKoR2K9o0Hy",
	"8rK2kcepM0EmEUowjCYoHD8PmiF+nVlWBdPx+ee5mRpOTC4Vdj3KIl7YfyXiyP419wH0iGHec6a7GV4X",
	"uWUKeheipf+SiOcNIwA2CVneeKj1AccrR2hfd7aJMA7CFxLUsswn9W8VZhzNCvoZffy3jT6OBx3P7YAR",
	"X45HuRgyxLcLA/oZwfxvEcHswZkUzv+Sq1KR3cb3ZY8EpHnVAVhw5AxUyYGZHoxQlXkd5oQvWMQYpQJQ",
	"1iOQzExiv0R01ASuIuAsxPlvCuZg4meOBAcDjBw7GDOxHMwBHhLKguS4jdjtf0AAdiS/dG2/aNt3hFRv",
	"fvlvHiJ9cHl07fhDTPR1llQQV+hTqeOZg7ypc2KhsgizRlggS/hsIToi1HsSZPxt7olvcS8sMop3H/UF",
	"7WS+kgX4snHEfI7hee5MX4g/+MtdV/FoaANNmv41F5CXx+iH0v23BOojwn2Gnj3IgqJRq+u7HKr2IEhA",
	"AbojiAj/AL3iqIUmGkW4QST/fDU6nD+M4jdR/dj+S8L552CtjOmv12rfFtMfDdNKBPbbmH1jXP8CNsOY",
	"fhPi/z2QuWlw/0GEbs+N8WXR9+4t54rv/bwkC2umBY0wilKntu9JrrKnJEjt5v++eVQLrnclqMo2IK4P",
	"BbhL9GhGeN6mfaLoX9bnazYTOnK+l5fNMpSWrE4Q9Q3JHjBSbSTlhtnMSWTpFF7TfGHgdEeWWnJwIjdb",
	"tmq9wl+80WHRqH6Pa/To4GrbhJH2wZXRdQElfQrZutQRGz+7g+GzRvezBOLZhdazvFCW7Cv2ybPn95/H",
	"aPY8gny0vhUmHFlGsFndUnKoeexg0pwKiS9vOl8BK6VXxJ6XVsJKsChljNkOoR2dZBSmjwOOhKqps1RW",
	"XHe/6lhvVXpsYexMdiNB82+Q0vcDpY41/sif6YT/PemEa7IIn/9uaYTPS/MI063CP3MJt8wl/LoCtZ3I",
	"qN+E1QAsFbGhi45QJuVN+c+Ua5dHbozURPbIePNRIvgUyCFIbIe72D21blbdOD7pQMiNI8LbMgR/Kd6f",
	"guzOLZC+j4kNYJiMQ5CYUjYGOvhEp+KAN0rUNciQhMoSQDA4GGBLRen0iBhRjsIeYY1FdS0jITAZhlee",
	"HCntwkx3jpCIB0L2zAKcqLIVTKtsmNDznJlKyIyWUp1PuiSIaAWJBsMHd4uypC0NTuz5xWLF0n3Uv9E/",
	"C/o3F/Kx/uXz/+lfLpot/cP/YY8jsad/Vf/Wv68PdUg7C8et6/cEBfV9a4zEcmcQJFp6kPdtp9u8PGje",
	"HoCOoEzqZZYDOQf7aoj8Yi1N80fOzLBl3dDuSGtvixFjoUtXMk1VntgGLep6vkDgkAwxCQIze6QbFjZU",
	"Ay2UGp1iMTLy3XHrGph4iqxxXWCudN+4CV0Hl+rqtnP3sioFFyuKGdYg7ZEPJsCV5aCHc3rLfR/besc/",
	"BJKMmU6KBSIG9TY1SucVdZOolEvU3yNVH8M1BY6gqL88gl9J9QafqkpxiEoo/8a2Gj0oEZoHHYRAGALk",
	"UN/ODykdmkA7ro+OqhRZCCuNmuKu8cqiKuTKdwTOGcjDKqSWQzniIhDSDP2RX00B0OB46oMZdvtNotmS",
	"vIvE07UXkYz8Lep2p7MRgxe1bhA0l/CqUeInOe34quOZ7xEV1WwOicK6CfyIpLOHgqWZRllL8uBeQaCF",
	"YQ4gQ3s9AkAOfJDC5t4fyIXYwfbXD3ugSYD6C0DbZohzrUow5DHElfoSzmXJIcDCsvLgiDJgsJcFH6CD",
	"LfS/keDKD3kzs7kfm7rfljDoqc0Qy+Z2ZznlqspBz/tf6HncoyI/NJ2CPlGQlOayLTbM+oN6thKuBRTY",
	"LiY8FQc2dSEme3/o/8oJFXmCjo8FAvpX8KvHsAvZ7Lfk5I6jJwxyZc1NC4Xpu4iROel9kCLVhwWY0qlu",
	"9dEMagBr5qDSRiGZ9UiA396C7KoOXOJUZEJhNDgPm25exuipe0k0Z7IZg+Dojz/k5YDw3v1+NV/V3SzH",
	"f15Mp4PcQsSGROT6DGI7VylWaqXKWiUpMlx2XQnZ40D130J4WJ07btiSNg7MjSq/Uk8P/1tq/vj6MuIL",
	"A357Ic12JJJmCwk66LZGF1SR57bWFzaJ0zkM2uuIJy76lIpNOx+FHVKFxMQcW5cJNl7edQZm1W4Vro+i",
	"K9sChNSY6WtGJ5jrkBhwd3u+UehzKnTRdKwf73zWpKh/3iArpjvzdPiAzlNcG4HU6cpWP8L1HH2sxtgk",
	"iwmrr7ERqUVmQ9tQHjyMEAkenShGy47LDlherC4m2PXdHrHRQFUV7s8i7ZRcE79cquXd6u5Ovby7s8zI",
	"pMX1Z+ptlFAY16Tm3c1bFumytfJOqaQx3U/pKkpw9Ry0+BqGyVMTyAV6kbxHIODIg0wyR9PaRlLj0sKu",
	"umCx4IBOSTBFHlyY8Xtk/uiDmUNqEVMktWM+ByP4ZnioerljrEwBDPUI9z19428RjaNx1VXjrr1IY1QS",
	"I4CFU/o5oEaVK5cMT8AecjBZqzWaZZrMCBB0M9rdyOhZYTiWHqUvFT6jE6qUw7BkdD71sg5g8XwWvIyU",
	"BMd8DJ+HMJ10xNS/FHiMUvGvCIyQh45XbdhI5ijaPpI8b04cqokZVP0yH1CFXgUCpFYUluczggM/TKQi",
	"6g0RQAc9wqkbJUOeNfF1LlQBaeExC+aMHbQeMUjIRwLuwpUHxyE12o73qbtBTmjgqfkg26tz9cGoPvmE",
	"K3dlhnrYfwWpm5XFAMiDVjw4tnN98EkytTllRdbOPfs1ZbmL+WB9LSWHIGUXjn/KEZyTzxKpFAU+7I2z",
	"IUNX7NbZoCaPMuSimw0Qr1ix0HmLe2xxnJX8KcjmjKNvq8TJrD7S+p8aaP3voHScya5MnPHIHR+ZCk7l",
	"NHDKcyOYYyMfm78i/+TQC/9808Dox10Q9OqxL/E/Iv1U0HZYyMD8FeSJmB/m8djZzFD5HoZWOMBQikyh",
	"QqOjQqIdMBU5Ke7BvhMfWn4IJ9Z/xD8ujsLgdD4PFamh5plsxsGTOARKqIBOTkf4UktCPeGeZF/zf+Xo",
	"BGaymSl3lmyRJOIzU+UtTlHJBItvsOK2ozHv8fG5b9McoapYkr1dnplPoBCI2JsHYp6FUfTbiMCepIEU",
	"t7r6nQPIhiZz31ws8kCoDEcGdNi+qqUhRSjJzGK2OEK5K34fUGahVQWxlmuLZoKwUtR8aP0lZ6O+P9ws",
	"1fTMVGX4hqTb+bRHOj+v5VDfzu1DvsSWqzLq4j3LxXKxuFus54up9kkV0ZGeOzimLzglcVD+PPL7m6Rc",
	"Qj5etEpUy2n6e+RpjDkclfUvuhnw51OZzZ2POMfK5yV7ExQAWjTESOI1efZEFXhJBBIRzYZ0y2XDL7tT",
	"Fd/fBDtpZyo93E+K5kueOxmiJSmNRjNLfhFUQCft0wIW1KTZ8MlS/VKo7pxdGmuVVS+gOdv5oFaNsfT9",
	"SBN/8xxEbax59jHWfCncaEvjj+60xvQzRjMVPpbkTB1kZPCgCXDgjPrxcBU/teCCA8nQTw/NDrwOOqcp",
	"8eBN1sRrMNmKINBHFnURB8bKnFVvlaEvvlIGpOwOGQIcWZTY0OSwR8y5iDzfdfJ33aNc471+7KtW+53n",
	"Jhzhhzz1aCwpe3+kPJuFiEi1STXVA5pKz1Tua45ENvTvDSgDAySskVTezCh50JaCDDKehn/5zPmX0hyQ",
	"CDT5bI9oxTWWMKvMDCaSXikdS3zeOiAsJTwNEjkWwiq5B5p6VuBXs9d7oFjeKVb7ZRvuoN1atW9Xqv1G",
	"v1GGjUoN1WC9bpf7O8XBAP6W1WFMfQaJNco5eIwAC6tyzMdjI+TMU/6lbPnbguct2SL9chwkky826GYS",
	"hFaH0x0ggZirVNjpCBnUaHde7Ek/FxI4RAz8akFiO8jD5DeAbUQEFjP9fqo+Xyo6ASq1IVGLFrQo4b6L",
	"GLDk4VKVQxbToiEHloMlacbbjBDpkfAshedAClHBwVpS6nbzmM/FCOYEIYzMViQtnOm315JrLa2YjbmM",
	"1AyptLm03vjPguJ/w4Li6duQqmwtuf/XLGY5ONn5qKsgWwEVVym2aGvt7Fv6pdFp8FLdd6sHFBgrTcqX",
	"oIEwkQdH2EFg6NB+3wSuhBaubI+gYR58UJnSfJT7fx8WuLtw/dSqxktf07synsLwNb0VcAXvMfYdSMa6",
	"bpuuhxPJcA2GiT3OCB6wY1vq2UIl9wTLMaup5kulfGIplXwFfrvjMfYK4/fYtNjjkMlIYkigEuZyglKH",
	"vxvuaAnOpDMs9QyrGjzcd1fscbCpQVPgc3nCmufHV3snzc6JMujGK26PYLm2s1cr1+qNho0qtl2tVnfr",
	"VrluV0v1cm2nUdnZ6ZeLlUYR7vR36sX6oAhLu/VitV5BVVv+YwdWB6lB+B5dspKlBWciKntSN8dD164t",
	"+6Tt7Cto/4+VNLPmeVttOV6qS+ssUWX5vPYdT4u874oohBylB9bvmy9Kcp2nqho/xlwuWplFO1uZsCY5",
	"glLijftHMIQCwVZVlV9iNnk20T7qjllpC1nMvg1Wm0ovCwhdpqSo2lQbaSphy7TpVHb7koRsmwyePZWy",
	"zTdIPL+AJEzx5mbIxaevjQC82WjBGF+Xgb0YnL8sAGFtdv+qia7XzaPPznPwnMdqP0doEk6fbLMDGzMk",
	"5HukGZQrVVUr9HX3wZRb+5AFH+YVuNRfpvLXBzBfh4oT7JE+msun6nZU9S/0iK6+6eJBX5TZOpbQY8hC",
	"ttLdsC74od3FkKuocamT9OkkNaw7UhfuzysHt3X5t82yzIbe0FR0jD/wP+dEoda1RNGal4ZbiJC6PgZj",
	"NAvLeMgrYO6LVnJ8XE+M3Xq5XPgWwPXxNbi+2z9vt8DZ4SPYP79qnanPPdIj7k37cv+4aXUsun/YPDgf",
	"NB5PxujtdAfazsXjtA6Pj9vOKXRE4/Sl/FrYL599HLUHbf/1WHj3L3XUI+e3w4O7+s4L7Na8+4Oae3Rx",
	"WvHGiKDbgtV1v3y5GV/ObvjoU5nefJoevt11+qXW5UVr0Doejj81bso98vY0Zm2rxY6KN+UpO+s70LdH",
	"dx/xPSTNA+6WGo+HX3i/1ryr1G1xxy4qN4/2w3D39uMnfD24b9z2yNn+S7dYmdzvX9kXHf5Y2T2HLbLT",
	"9kpXE6/RPqSFNjq8fyx9cVtX1014VuyfnlT8wbDa8tGYf+x2emR689BFrfNX/+l85+riE726PptOLm4G",
	"r/1h6dNBY+I/Fc/ES8G6PCm/Qr/46vKmv3ty6qHx5Or69tXpkdkX8TJ7GjB6j9HRzJs+DSc3U0HIRaMw",
	"7Bz6hdP7Lnss1sru4V233rL69erYOjnqHg0uxg4ZHxd6pDi4qzZvYa1YPam8vhTHoo8qkzPr+hO9vvLP",
	"9u/5SWdSLN4dPzZn18iffWzUrbvC4+Hooj6udO7PXnpkB7WfhjN8cVWcOqXH44PbM8t3pmO+2/zoO+Nh",
	"iXb7VV55c58m18X6Me2+PlTLL/Cs9tD5eDl6QqhHGjvFT/R+1LdKZ17n48vgib5wdiieGtf9u6ePj5Oj",
	"xq3H7Icmeznpn47Lp97tWfO1O3rlN02+Pzou9Ujx3H8tP8CL/eKw3K5dWxf2acH68kKLDctiL/uffPz6",
	"wHAN+7sXn7zGl25h0Hm7dLndHpJG4cvTWY/gxo3vDPx63f8yeihMRbkvCBbDW/7lZfR64b883lWf+tXR",
	"WBw1Rmd3hU+f6tXyl9F57WzavG3eNPd7RBwcHT893E4s93B4dnBROus0G0/u/bhfOR2ddy9K55/2Z/Ch",
	"NLKI0wx+t05OJ9C9f7FbtUmPWK71Ed+cXu3vX+y3ms3qET48RCc7LhsdndT9e35zfnFRLj7WrKcReX1s",
	"HDVdRUOt42njqDUdt3tkf9o+Prqhp60mb+3vP7aa08PWyfCwdVRtNlvD8c2898fLx2ahvv/oDZ1Zp/n0",
	"eDJ6mZ2NeqTwcbDzdj24n/RPysXDL5Vxu351tH9ZJOefPu7flVx/0vn4pet3Kg/nbL/iVo59R3hnt4en",
	"Z+fCrR0e9EiJHb99atJuaebtPrYb580D+6LVupq9NF84fbhr1B/v/NbHQp+8sC66LZ/fXrUGs+tWfedh",
	"t1HDV/c94tY6H/v85mBab5XPmWM3L6oXBz6dPZU6WBzDp+rZzfm9+Ng9hKUq5o+d49bLG61fPzbuK6dX",
	"41qxR4ZfHoaN8mWh75YP3zr1bqPycHjQLzmTl2rbmbwO21/O0LBUevv0+Oqyx87T6WlrMHkbfHQuOzv+",
	"6/CkR15eC6fFmfNUPsf9Y7Zz3GzOrnbvHljzqTPtXBQPrZduY3rYIq/jzoE/++I+TO8nl/uf/MP2feMK",
	"VR575ALflQanlw1u1w88fvRau/j4ySYX5Kbz8YS9dK/PDiruA3OaNjnsjuzH+8bL09h7GB3MeKWwu4uu",
	"emQ0LrJzMiu+XE7H0B8U8F3jytr5NLkYv5zfXpwOa3e792ezU//hQbxNP5GXi8vaw+3R/pezKn+i7sVF",
	"jwxEv3tS+lib9W8fCs3KZL8PX28fyqJ+93b5Yr2hcefpEMPzy93zwol12mrflm6OGjuN8oHddA6Pdu0e",
	"GZeHN/ixc9OE8LR4etp8O5ncjm9Pz8+HZ+XHm0d8cnk/K4vK6exowBl0a9NO6+FqMLpG7dn5fvfptEcm",
	"zLt0rvtowLu7tXp3UN6/bPvDtyfWqt2/HnTOxk/D21Hp/njSad+Q1uxtfDPbObwrf7n28ENtV/Ko0XX7",
	"0xM7o9ZZ5ey8s1vAb6c33VtHvFw0f++R368H3bp6UUa/KbPi6llStI4y9My5k35J/yx9uv7ds5VW6+/1",
	"Dlq0hleqcUiOF6jqutCXsv1HpCLIpUDDgVK5Iskjqn5Yj/waBC39llpLLJE+ENSaplvWy/u+5v64RR8s",
	"MehvWIXAvJu8nV6dKko2bTv0JwamYfPCGfTFiDL8hmylzyRT2Td6sKzZecBifHVSvWvUq4c2378jM9Gv",
	"9KeT2+HwxLlx+o+fnDopFSe7S4pdp2bE3+ln3kL1R6dEmfen5ZGK269sF5P1wd1cxQ9IPKVpxxsnKX+H",
	"ZGPQn0WeE0spkR2UNLXTORFp6y6l75KFvBYaMlDxWXxrYFzIx5vCItuuhUTnZW+LlVQai9odkhaXDYoF",
	"6hGiRgXNVCzEhL1FZ9l8lVliib0lGfvMqO2HyUErSwcvlOf7RtNNYpjl0C8uNGkZ9gV9NmXx4cJjlKt5",
	"5eIupJTGIvoNHo/yLUaNFWJcANYSeKIrIxmuG0vf4shiSOT0A5DhVR4+uJhWbRBy9JxqGEnaRTYQDwJn",
	"YWy4ZTVdKBtCErF4RePJqsVKuZruK7fW352h6X7gwGGQqM1Gli4doN2bkWI9QW41dDg19V8Ng+KgbVa0",
	"cPsvW1O8elH0vZL5tuYlrUYQuxavC9dJDG/ZxTMRgyGywZHNSbuEupEinltEHQXd1sQdEeFpqFbECBHh",
	"gaBRTM4q5gllYpSDLmLYgnmPUidPhCfl3Ew2U1r1eSvBLFrIdLnvMWiVDS4MdYncdVsxyeCuUziE8pyR",
	"zSI4k44NMtv4gcrF7KC1fTqV7bokajmsnePNZ2i7LkueklnXLSXIb12XRHTXug7L/E9fP6dznkD30O+A",
	"JVOnVM0CzAEfUd+xAUMqlKKvKkJfDUDfFyC5SToTTUXECZX6krL3eaDGdREkJmoLOg5IaQj0yeM9AhnS",
	"jE/rFol5YdjWcMkJpsp/rW3zEuAeYb6DdH1ohgaUoSyYIjCCk7BKhjrNQGXmyNX1EYBTGBQHwwJgTj6I",
	"HvEo57ivS525+FUFDblQWCPtJDD7AQQdKo1IMuWQdpb5sCIZdts8+rqQpbExSW3YYzFLewuC2rBH+vND",
	"G9PGhu2XeBK3oNroE7DbJ+KEqTybJK2azECdtbrsFTXjlw6OzeeFA7Zl6g3zCVmWXxNLVEyc260X9M6c",
	"0nT3/MKQn5deXcvzhPK8EiboBOlA0ZwaauG8YTG6PopEoO94eZNVbJ5ESEfh9u/Oz9/ceNdD7gn5++cz",
	"6+97Zn0DfWWzcCAlhls+w2LWkUddb/s+gkyflb7611Ew3elDVwrNqqUU5nW7cFSpC+kqu5gMaFrgvC78",
	"IqgxF6oCTDr4Syem8rzK/rKQqWuuNzHT9KA1QqCskmaUwhCalafTaR6qz8qWa/rywnm7dXjZOcyV88X8",
	"SLiOFlqFOghXnX01vUmRZEBVOALQw5Homr1MOXgyRH7Yy1TyxXwpowtOKjQVLIcSxAt/YPuropa0GlzH",
	"SIexaJ6pqnEBw+jkuVEhoEgEz8TpJxRh+KSqEX50pfaIeZMyVb5lnjqsymhgSoBiscjWuaphceC2rUGJ",
	"Pleugsqhi4RSNf6Z8mByUAAgAF5QMFRVwDBRZ0+MgqCkveDxyuDEaaVPs88f8qr4ZzmbLoCvNqNcLEai",
	"+k1Gm2Pc/oUXU1t5DtBKcSCCpa/JStNRnMgjUv2OU5tE3eSkbaKFTnMyALb11KUfP3XTV7VUx0hZ0LEG",
	"RM9e+fGz35G5EVyeQA8xeTZAeLY1JNU/A5IxoVOysAW1P2P37wh69XTsuEr+BtRSDznZMRauqDhg3v/8",
	"LGmE+64L2cykvkeZkGJe4XlS4xSCP1QV1LS3NFu6/A8EBE2DrlngUbl0HAS5c1NqUNmOJ4jBgLkrfm9U",
	"PPWYtHZ2YBZV+HiScV1TLgyvNkwGcbFP7dn3o/j4u+pf49enZGZfE/ym9L1nb9tpW28+qnoXSvxA9l/G",
	"dNj8sfOfnOcn59mQ8ximkcZpvpfwtIW8FOBwjaAUe5R9I1EpHPi/TFiKYSrlBMXx8lNg+sm2/qYC01L+",
	"pRXBqNSUIr/IJnMhZgN+EmFW/0Zc5AfIXhHMqIH/bOkrMn/4plrKkVJ1ydB0XkC1r8p3mcfw0/maQK+i",
	"oOw4cXgWUbsx96p+rwnSaPNr7NaWaImVDl9BAI4p2vEtt/gAE8xHkUscrLzDsZhf3VmlUSiXjIsEBJjo",
	"M4wpAbBPfWGC/bnviFXXvKo58vOSX3vJKzwtIQ15BMIK79qbFyqImABC9Ruvlu9AZuq6gV/FiPrDkfGn",
	"nXauLn/L/8cR0rEqXz4MHJ3BKU8jIxcSPEBcrKelsOUG5HSLhM8IV9lIQT8FjNLBDTsjhlQUfzcVLsPG",
	"FlWEFdZ+MtsXVPiEAkTNsaZgo47thaRg/s4Fw+VrK0jxIkTBT3pcS49zZC0hyth2JwjzP5PW4uSxAdFF",
	"MqFX01xYp0WSXILO9OMK6BVaInYRMUV+yAY20qXUaIzWQtO/Ko27ijICOH8SxnrCCB+nXUIXwVZuQxc/",
	"ldSfSuq/m5Ka4E3r+R3vU3e5gBEICxDo2Kl4iVy+Rm7okYXmkIVtVDXdeUHfpSa3/auLLS9/CZMOuNJs",
	"DgRj/JeY3tRql3A69fG/7fqfL3qRFGzzeHoh9nb8crNN8Nj6fuSB9h9hBFl8PH8jG0jxB0y/3P4RtLHD",
	"1DEHB76gP/GqDHbwpzMqeWH+XW6t4CjpAhlMR6yGFMkNqUYe9I7eV4mLI/Hw+o8klMW5vq55iTz2MMLf",
	"TLCAjhM+ARBU1AJ26upmIHjuXO2dmnXlps0fJU9c9WlLnjcpqNK2y4JmI+1U7dsfev/O15DGLsLnOQ0y",
	"fvKpv0aw1xTw9xPr5++7SjoMw/2D0zQns/U+dEjCopUBQWvI5tUv+zOg5Nd0Qt3cY4VM83eJ3pU/WZBe",
	"upXqA4j+9pOKf1LxNlSMkidIUm4YVrz8hrwyTd557hcjvhMLNaAoXiB1dTlE8AD/39ASsnI5X8O80zQu",
	"dmHe7VQp2uqx2fBBg3jQOfRwXlVIHeGBTviFHi7oh1OUrwOxXPBocGFSVtLKQii8gENMhqsm4AIO0Tun",
	"sfSDRuZd0XCadeN8/vr/AwAA//+JKJEuatUAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
